from .shfLam import *

import   jax as _mb_jax
import functools
import inspect

_JC_LOC = ['locate','L','loc'] # file.pth
_JC_DRC = ['direct','R','drc'] # dir.name
_JC_LOT = ['layout','E','lot'] # mkldnn sparse ..
_JC_DEV = ['device','V','dev'] # 地环
_JC_DYP = ['dtype', 'T','typ'] # data.type
_JC_TAN = ['train', 'P','tre'] # metaclass=num.MetaM3X.train]
_JC_RAN = ['tests', 'B','vlu'] # metaclass=num.MetaM3X.eval ]
_FC3DEV = ['cpu' , 'cud' , 'gpu']
_FC3REV = ['otg' , 'non']
_FC3PEV =[ 'rut' , 'cut' ]
_FC3DYP =[ 'int' , 'uin' , 'shr' , 'lon' ,
           'flo' , 'bfl' , 'hal' , 'dou' ,
           'com' , 'boo' , 'qin' , 'qui' ]


_fc_bit_def = '64'

_JC_IMP_tto = ['device','dtype','layout']


# 模型有三: 基础模型 角色模型 策略模型
# 基础模型: 网络层有规律的封装
# 角色模型: 对基础模型或其他角色模型的组合
# 策略模型: 

#
class MetaM2X(bas.MetaPre):#自动梯度(第2代)多态(X)混算模型(M)元类(Meta)
    import jax
    Mud = object #JAXMOD
    #MetbM3X.
    # JAXの类辑
    def __new__(ido, jc, ns,cig):
        # ... 与 JAX 相关的元类逻辑 ...
        if not any(BB_(ss, MetaM2X.Mud )for ss in sh):
                       sh=(MetaM2X.Mud,)        + sh
        cig[ 'to'] = lambda ego, *args, **g: ego  # JAX 框架不需要 `to()` 方法，此处仅为占位
        _mb_jax.device_put()
        cig['gel'] = lambda o, x: o.apply(o._zx if y is NON else y,x)
        cig['gal'] = lambda o, x, y=NON: o.apply(o._zx if y is NON else y,x) #_mb_trc.func.functional_call
        return super().__new__(ido, jc, ns, fg)



#@contextlib.contextmanager danijar-ninjax
def scope(name, absolute=False):
  """Enter a relative or absolute name scope. Name scopes are used to make
  names of state entries unique."""
  global SCOPE
  if SCOPE is None:
    raise RuntimeError(
        'Purify stateful functions with fn = pure(fn) before running them.')
  outside = SCOPE
  if absolute:
    SCOPE = name
  elif SCOPE == '':
    SCOPE = name
  else:
    SCOPE = outside + '/' + name
  try:
    yield SCOPE
  except Exception as e:
    if not hasattr(e, '_njscope'):
      e._njscope = SCOPE
      if hasattr(e, 'add_note'):
        e.add_note(f"This happened inside Ninjax scope '{SCOPE}'.")
      else:
        print(f"Exception happened inside Ninjax scope '{SCOPE}'.")
    raise
  finally:
    SCOPE = outside


def _scope_method(method):
  @functools.wraps(method)
  def wrapper(ego, *args, **g):
    with scope(ego._path, absolute=True):
      with jax.named_scope(ego._path.split('/')[-1]):
        return method(ego, *args, **g)
  return wrapper

class MetaMAX(type):
  """Meta class that creates a unique path for each module instance &
  wraps the methods and properties of the module to enter the name scope."""

  def __new__(ido, jc, bh, km):
    """ This runs once per user module class definition.
    It wraps the methods of the module class to automatically enter the name scope of the module."""
    method_names = []
    for key, value in km.items():
      if key.startswith('__') and key != '__call__':
        continue
      elif isinstance(value, property):
        km[key] = property(
            value.fget if not value.fget else _scope_method(value.fget),
            value.fset if not value.fset else _scope_method(value.fset),
            value.fdel if not value.fdel else _scope_method(value.fdel),
            doc=value.__doc__)
      elif inspect.isfunction(value):
        method_names.append(key)
    cls = super().__new__(ido, jc, bh, km)
    cls.__field_defaults = {
        k: getattr(cls, k) for k, v in cls.__annotations__.items()
        if hasattr(cls, k)}
    for key, value in cls.__annotations__.items():
      setattr(cls, key, property(lambda ego, key=key: ego.__fields[key]))
    for method_name in method_names:
      method = getattr(cls, method_name)
      method = _scope_method(method)
      setattr(cls, method_name, method)
    return cls

  def __call__(cls, *args, name=None, **g):
    """This runs once per use module instance creation. It derives a unique
    name and path for the module instance."""
    if not isinstance(name, str):
      raise TypeError(
          "Please provide a module name via Module(..., name='example').")
    if not re.match(r'^[A-Za-z0-9_]+$', name):
      raise ValueError(
          'Only letters, numbers, and underscores are allowed in scope names; '
          f'got: {name}')
    fields = {}
    for key, typ in cls.__annotations__.items():
      if key in g:
        value = g.pop(key)
      elif key in cls.__field_defaults:
        value = cls.__field_defaults[key]
      else:
        raise TypeError(
            f"Pass a keyword argument for field '{key}' or define a default.")
      if typ is not None and not isinstance(value, typ):
        raise TypeError(
            f"Value '{value}' for field '{key}' is not of type "
            f"'{typ.__name__}'.")
      fields[key] = value
    obj = cls.__new__(cls)
    obj.__fields = fields
    with scope(name) as path:
      obj._path = path
    obj._submodules = {}
    init = _scope_method(cls.__init__)
    init(obj, *args, **g)
    return obj


class a:
   def l(ego):ego.__call__ = lambda:3
   def __call__(ego): print(5)

#TODO 适配JAX(不含Opt等外)，或在包外实现：__init__ 的import决定
class MetaM3X(bas.MetaPre):#自动梯度(第3代)多态(X)混算模型(M)元类(Meta)
    # PyTorchの类辑
    import torch as _mb_trc
    NmC = _mb_trc._C
    Jit = _mb_trc.jit
    Nys = _mb_trc.__dict__
    Dev = _mb_trc.device
    Mud = _mb_trc.nn.Module
    Mod = _mb_trc.nn.modules.module
    Cal = _mb_trc.func.functional_call
    #
    @staticmethod
    def RealObj(x,t=NON):
        if  BT_(x,str):return{'device':MetaM3X.Dev(x)}if t=='V'or x[:3]in _FC3DEV\
                         else{'dtype' :MetaM3X.Nys[x]}if t=='T'or x[:3]in _FC3DYP\
                         else{ } # FIXME
        if x in TYP_0N:return{'dtype' :MetaM3X.Nys[x.__name__]}
        return {x.__class__.__name__:x}
    #构造的类继承自Module
    def __new__(ido, jc, bh, km):
        #if '_dg' not in cig or not BT_(afs['_dg'],TYB.TSX): raise TypeError(f"类 {jc} 必`_dg`")
        if not any(BB_(bs, MetaM3X.Mud )for bs in bh):
                       bh=(MetaM3X.Mud,)        + bh
        def to( ego, *c,**g):
            #更 ego._dg
            for   x in c: ego._dg.update(MetaM3X.RealObj(x))
            for t,x in g: ego._dg.update(MetaM3X.RealObj(x,t))  # 实毋管其称
            return super().to(**ZTR_DIC(ego._dg, _JC_IMP_tto))  #super()之于其栗
        #object.__setattr__(ego,'_functes', dict()) #CECK 不删注释是为了更好查找
        super().genrTkg(('_functes',       dict),km)  # 定义_functes，保存无参纯函数
        super().genrMkg((('complie',ido.genrCmp),     # 定义__call__()的编译，一旦则cal()
                        ('__call__',ido.genrCal)),km) # 定义cal()及其附计为__call__的主要
        return super( ).__new__(ido, jc, bh,km)
    
    @staticmethod
    def genrCmp(am, *_):
      def _(o,*c,**g):o.cal = MetaM3X._mb_trc.compile(o.__call__,*c,**g)
      return _
    
    @staticmethod
    def genrCal(am, *_): #()=ido.genrCal(am, *_)
      def _(o, *c,**g):
        s = MetaM3X.NmC._get_tracing_state()
        #called_always_called_hooks, *hooks = None, ([],..)#no hook, skip and just call forward.
        if not s or isinstance(o.cal, MetaM3X.NmC.ScriptMethod):return o.cal(*c,**g)
        recording_scopes = MetaM3X.Jit._trace._trace_module_map is not None
        if recording_scopes:
            # type ignore was added because at this point one knows that
            # torch.jit._trace._trace_module_map is not Optional and has type Dict[Any, Any]
            name = MetaM3X.Jit._trace._trace_module_map[o] if o in MetaM3X.Jit._trace._trace_module_map else None  # type: ignore[index, operator] # noqa: B950
            if name: s.push_scope(name)
            else: recording_scopes = False
        try: return o.cal(*c, **g)
        finally:
            if recording_scopes:s.pop_scope()
      return _

        

# 
def initPar( jc, jg, *c,**g):
    par=bas.Dih(dict(zip(jc,c)))
    par.update( jg)
    par.update(  g)
    return par


class MetbM3X(MetaM3X):
    #@ TYB._SM #已经不必要，因为祖类已实现ini的前父__init__逻辑替代
    #def initMod():return lambda o,*c,**g:MetaM3X.Mud.__init__(o)or o.ini(*c,**g)
    @ TYB._SM
    def gitrMod():return lambda o,*d:o[*d]
    
    @functools.lru_cache
    def getrSub(ego, k):
        if k in ego._functes:return ego._functes[k]
        if k in ego._modules:return ego._modules[k]
        if k in ego._buffers:return ego._buffers[k]
        if k in ego._parameters:return ego._parameters[k]
        raise   NotImplementedError
    
    @staticmethod
    def genrGit(am, *_):#[] Fixme 多暗刻单骑 '_parameters' '_buffers' '_modules'
        return lambda o,*c:am['git'](o,*c)if'git'in am\
                      else bas.Dih(o._parameters)[*c]if'_parameters'in am\
                      else bas.Dih(o._buffers)[*c]if'_buffers'in am\
                      else bas.Dih(o._modules)[*c]if'_modules'in am\
                      else None#if c[0]!='dic'else super().Git(o,*c)

    @ TYB._SM # FIXME toC and cpl as .so
    def genrCal( fg):
        if BT_( fg,tuple):
            _fc = fg[0]
            _fg = fg[1:]
        elif BT_( fg,dict):
            _fc = fg.pop('fc','DfG')
            _fg = fg

        if _fc[-3: ]=='NsG':
            if  BT_(_fg,tuple) and len(_fg)==1: _fg = _fg[0]
            if  BT_(_fg,str): _fg=[_fg]
            def forward(ego, *c):
                if len(c)==1: c=c[0]
                for v in _fg: c =ego.getrSub(v)(c)
                return c
            return forward
        if _fc[-3: ]=='DfG':
            def forward(ego, *c,**g):
                par=initPar(*_fg['oi'],*c,**g)
                for _ass in _fg['ox']:
                     par[_ass.ius]=MetbM3X.getrSub(ego,_ass.opa)(*[par[_] for _ in _ass.ons])
                return par[_fg['ou']]
            return forward
# 
def fff(fo):
    #@ wraps(fo)
    def genrCal(ego,cfg):
        # modBased \ netGraph \ datGraph forward
        if cfg['fc'] in ['mod']: return Mod_neo(cfg)
        if cfg['fc'] in ['EDG']: return None # todo sequence and jj
        if cfg['fc']=='Seq':
            def forward(ego, *c):
                par=bas.Dic(zip(cfg['oi'],c))
                for k,v in cfg['ox'].items():par[k]=ego._modules[v[0]](*[par[_] for _ in v[1:]])
                return par[cfg['ou']]
            return forward
        if cfg['fc']=='DfG':
            def forward(ego, *c):
                par=bas.Dic(zip(cfg['oi'],c))
                for k,v in cfg['ox'].items():par[k]=ego._modules[v[0]](*[par[_] for _ in v[1:]])
                return par[cfg['ou']]
            return forward
        
    return genrCal

#def
"""
A: 若需类之行全变，或于定前，以元类编；
   若需类之行孤变，可于定後，以修饰编。
""" 