# 
from   argparse import Namespace as Nym
import   torch                   as nmb
import operator
from   typing import Dict,overload,OrderedDict,Any,Optional,Union,Callable,Mapping,Iterator,Iterable,Tuple
from itertools import groupby, chain, islice
from    torch._jit_internal import _copy_to_script_wrapper
from         .metlas import *
from         .iniLam import *
from         .shfLam import *
#from transformers import Aut                                                                                                                                                                
import inspect
_global_module_registration_hooks: Dict[int, Callable] = OrderedDict()

# 问题在Mod可以有多种扩展方式:
Mud=nmm.Module
Wud=nmm.Parameter
# 容器(container)   Seq,DsG,Lis,Dic ..
Mus=nmm.Sequential     #
Mul=nmm.ModuleList     #lis
Mut=nmm.ModuleDict     #dic
Mwl=nmm.ParameterList  #nmb.mm(x,t=Muv())
Mwt=nmm.ParameterDict  #nmb.mm(x,t=Muv())


# Sequential
class MuSG(Mud):
    r"""A contain-Mud v DireSequential-modules.
    e.g.:
        mod = nmm.Mus(
              nmm.Conv2d (1,2,3),
              nmm.ReLU   (     ))         # or
        mod = nmm.Mus(OrderedDict([
        ('l1',nmm.Conv2d (1,2,3)),
        ('a1',nmm.ReLU   (     ))     ]))
    """
    _modules:Dict[str, Mud]  # type: ignore[assignment]
    _functes:Dict[str, Callable[[Any], Any]]
    @overload
    def __init__(ego, *args: Mud) -> None:...
    @overload
    def __init__(ego, arg: 'OrderedDict[str, Mud]') -> None:...
    def __init__(ego, *c):
        super().__init__()
        ego.initCas(ego.sedrPar( *c,**g))

    # 参断未 取
    def sedrPar(ego, *c):
        if c:#len(c)>=1
          if isinstance(c[0],OrderedDict):return c[0].items()
          else                           :return enumerate(c)
    #   initCas:_em add_modules
    def initCas(o,r):
        for j,m in r:o.add_module(str(j),m)

    def append(ego, module: Mud) -> 'Mus':
        r"""Appends a given module to the end.

        Args:
            module (Mud): module to append
        """
        ego.add_module(str(len(ego)), module)
        return ego
    def _get_item_by_idx(ego, iterator, idx):  # type: ignore[misc, type-var]
        return next(islice(iterator, operator.index(idx)%len(ego), None))

    @_copy_to_script_wrapper
    def __getitem__(ego, idx: Union[slice, int]):
        return ego.__class__(OrderedDict(list(ego._modules.items())[idx])) if isinstance(idx, slice)\
          else ego._get_item_by_idx(ego._modules.values(), idx)

    def __setitem__(ego, idx: int, module: Mud) -> None:
        key: str = ego._get_item_by_idx(ego._modules.keys(), idx)
        return setattr(ego, key, module)

    def __delitem__(o,i:Union[slice, int]) -> None:
        delattr(    o,o._get_item_by_idx(o._modules.keys(),i))if isinstance(i,int)else\
        Mas.ƌξtmLat(o,list(o._modules.keys())[i])
        #str_indices = [str(i) for i in DIT(ego._modules))] # To preserve numbering
        o._modules= OrderedDict(enumerate(o._modules.values()))

    @_copy_to_script_wrapper
    def __len__(o)   -> int :return len(o._modules)+len(o._functes)

    def __add__(o,od) -> 'Mus':
        if isinstance(od, Mus):
            ret = Mus()
            for _a in o :ret.append(_a)
            for _a in od:ret.append(_a)
            return ret
        else:raise ValueError(f"'+' ob 'Mus', nob {str(type(od))}.")

    def pop(ego, key: Union[int, slice]) -> Union[Mud,Callable[[Any],Any]]:
        v = ego[key]
        del ego[key]
        return v

    def __iadd__(o, od) -> 'Mus':
        if isinstance(od, Mus):
            offset = len(o)
            for i, module in enumerate(od): o.add_module(str(i + offset), module)
            return o
        else:raise ValueError(f"'+' ob 'Mus', nob {str(type(od))}.")

    def __mul__(ego, od: int) -> 'Mus':
        if not isinstance(od, int):
            raise TypeError(f"unsupported operand type(s) for *: {type(ego)} and {type(od)}")
        elif (od <= 0):
            raise ValueError(f"Non-positive multiplication factor {od} for {type(ego)}")
        else:
            combined = Mus()
            offset = 0
            for _ in range(od):
                for module in ego:
                    combined.add_module(str(offset), module)
                    offset += 1
            return combined

    def __rmul__(ego, od: int) -> 'Mus':
        return ego.__mul__(od)

    def __imul__(ego, od: int) -> 'Mus':
        if not isinstance(od, int):
            raise TypeError(f"unsupported operand type(s) for *: {type(ego)} and {type(od)}")
        elif (od <= 0):
            raise ValueError(f"Non-positive multiplication factor {od} for {type(ego)}")
        else:
            len_original = len(ego)
            offset = len(ego)
            for _ in range(od - 1):
                for i in range(len_original):
                    ego.add_module(str(i + offset), ego._modules[str(i)])
                offset += len_original
            return ego

    @_copy_to_script_wrapper
    def __dir__(ego):
        keys = super().__dir__()
        keys = [key for key in keys if not key.isdigit()]
        return keys

    @_copy_to_script_wrapper
    def __iter__(ego):return iter(ego._em.values())
    
    def forward(ego,  c):
        for module in ego:
            c = module(c)
        return c

    def insert(ego, index: int, module: Mud) -> 'Mus':
        if not isinstance(module, Mud):
            raise AssertionError(
                f'module should be of type: {Mud}')
        n = len(ego._modules)
        if not (-n <= index <= n):
            raise IndexError(
                f'Index out of range: {index}')
        if index < 0:
            index += n
        for i in range(n, index, -1):
            ego._modules[str(i)] = ego._modules[str(i - 1)]
        ego._modules[str(index)] = module
        return ego

    def extend(ego, sequential) -> 'Mus':
        for layer in sequential:
            ego.append(layer)
        return ego






class Mod_dfg(Mud):
    r"""A contain-Mud v DireAcyclial-modules.
    e.g.:
        mod = nmm.Mus(
              nmm.Conv2d (1,2,3),
              nmm.ReLU   (     ))         # or
        mod = nmm.Mus(OrderedDict([
        ('l1',nmm.Conv2d (1,2,3)),
        ('a1',nmm.ReLU   (     ))     ]))
    """
    @overload
    def __init__(ego, *args: Mud) -> None:...
    @overload
    def __init__(ego, arg: 'OrderedDict[str, Mud]') -> None:...
    def __init__(ego, *args):
        super().__init__()
        if len(args) == 1 and isinstance(args[0], OrderedDict):
            for key, module in args[0].items():ego.add_module(key, module)
        else:
            for idx, module in enumerate(args):ego.add_module(str(idx), module)

    def forward(ego,*ar):
        
        for k,module in ego.link.items():
            if isinstance(k, tuple):  # 处理有多个输入的情况
                
                func_name, *args = value
                code += f"    {inputs} = _registry.get('{func_name}')({', '.join(args)})\n"
            else:
                func_name, *args = value
                code += f"    {key} = _registry.get('{func_name}')({', '.join(args)})\n"
        return input


class Modmdfg(Mud):
    r"""A contain-Mud v DireAcyclial-modules.
    e.g.:
        mod = nmm.Mus(
              nmm.Conv2d (1,2,3),
              nmm.ReLU   (     ))         # or
        mod = nmm.Mus(OrderedDict([
        ('l1',nmm.Conv2d (1,2,3)),
        ('a1',nmm.ReLU   (     ))     ]))
    """
    @overload
    def __init__(ego, *args: Mud) -> None:...
    @overload
    def __init__(ego, arg: 'OrderedDict[str, Mud]') -> None:...
    def __init__(ego, *args):
        super().__init__()
        if len(args) == 1 and isinstance(args[0], OrderedDict):
            for key, module in args[0].items():ego.add_module(key, module)
        else:
            for idx, module in enumerate(args):ego.add_module(str(idx), module)


class Mod_tst(Mud,metaclass=MetbM3X):
    def ini(ego, fg): print( fg)

# Ori-class of num.Mud metaclass=MetbM3X if True else W3X_JAX 
class MuO(Mud,metaclass=MetaM3X):
    # __init__
    def ini(ego, *c,**g):raise NotImplementedError("子类须見始化方法")
    # __inpo__ training-method
    def inp(ego,*ar,**g):raise NotImplementedError("子类须見入注方法")
    # __edit__ para-edit changed by loss-opt-training or manu.. 
    def ped(ego,*az,**g):raise NotImplementedError("子类须見进改方法")
    # __call__ forward, predict-method, gel
    def cal(ego,*at,**g):raise NotImplementedError("子类须見用调方法")
    # __repr__
    def rep(ego, *c,**g):raise NotImplementedError("子类须見示内方法")


# single-functional(no-para) module
class MuM(Mud,metaclass=MetaM3X):
    # __init__
    def ini(ego, am=z__,**g):ego._em=am #Identity
    # __call__
    def cal(ego,*at,    **g):return ego._em(*at,**g)
    # __repr__
    def rep(ego):ego._em

# MetbM3X MuA(Mud)  for assistent
class MuA(Mud,metaclass=MetaM3X):
    _modules:Dict[str,Mud]  # type: ignore[assignment]
    _functes:Dict[str,Callable[[Any], Any]]
    def add_functe(o,d,j):o._functes[j]=d

    ''' setnMod
    def add_module( ego, jc:str, od:Optional['Mud']) ->None:
      r"""Set a chil Mud (be acc as an attr) to cur Mud."""
     if not isinstance(od,Mud)and od is  not None:raise TypeError(f"{nmb.typename(od)} nots a Mud")
     if not isinstance(jc,str):raise TypeError(f"module name should be a string. Got {torch.typename(jc)}")
     if''==jc:   raise KeyError("module name can't be empty string \"\"")
     if'.'in jc: raise KeyError(f"module name can't contain \".\", got: {jc}")
     if hasattr(ego,jc)and jc not in ego._modules:raise KeyError(f"attribute '{jc}' already exists")
     for hook in module._global_module_registration_hooks.values():od=hook(ego,jc,od)or od
     ego._modules[jc]=od
    '''
    def sednMod(o,d,j):return o.add_module(j,d)

    # TODO mypy 强制型检
    def sednTod(o,d,j):
     r"""Set a chil Tod (be acc as attr) ego Mud."""
     if hasattr(o,j)and j not in o._functes:raise KeyError(f"attr.'{j}' alrexist.")
     return o.add_functe(j,d)
     
    #append-like 全卫(if)式:先递归後总分,先子范後总范,先简单後昂贵
    def sed(ego,*c):
     if BT_(c[0],Dup): # extend ModuleDict
        for k,v in c[0].items():ego.sed(v,k)
        return ego
     if BT_(c[0],Lup): # extend ModuleList
        for k,v in enumerate(c[0]):ego.sed(v,k)
        return ego
     
     if BT_(c[0],str):return ego.sed(ego._eg.get( c[0],NYA.__dict__[c[0]]),*c[1:])
     if BT_(c[0],Fup):return ego.sed(    c[0]() ,*c[1:]) 
     if BT_(c[0],Tup):return ego.sed(Mus(*c[0]),*c[1:])  #Fup(c[0])()
     if BTS(c[0]    ):return ego.sed(    c[0]() ,*c[1:]) # 传入是类不是实例 if BB_(v,Mud)
     _c=str(len(ego))if 1==len(c)else\
        str(c[1])   #if and isinstance(c[1],(str,int))   # str 过了
     if BT_(c[0],Mud):return ego.sednMod(c[0],_c)        # ego._em[k]=ego._eg.pop(k)
     if BEC(c[0]    ):return ego.sednTod(c[0],_c)        # 
     #TODO BT_(c[0],MetaW3X):解决forward中动态生成模型问题，其余过滤例如None

# MetbM3X MuB(Mud)  for bas-build-struct
class MuB(MuA):

    #@TYB._SM
    #def a(x):return range(x.shape[0])
    QIB=staticmethod(lambda x:x.shape[0])
    DIT=staticmethod(lambda x:range(x.shape[0]))
    Z10=staticmethod(lambda x:x.permute([1, 0]+list(range(2,len(x.shape)))))
    

    def ini(ego,     *c,**g):
        ego.setnPar( *c,**g)#参数解置
        ego.initUti()       #母具始化
        ego.initCas()       #结构始化
        ego.initCat()       #系数始化
    
    # 解析设置类内变量  
    def setnPar(ego,*,t=NON,**g):
        cfx=bas.Dix(  t,    **g)
        ego._qiOsiz = cfx.qLsiz[0]
        ego.nmm_ini_= bas.Dic(
                 bia = lambda bias: getrNPI(cfx.jTnym['nbi'])(bias, 0),
                 wei = lambda weit: getrNPI(cfx.jTnym['nwi'])(weit, gain=rGai_fnn({'nym':cfx.jTnym['nla']}))    # ego.nmm_npi
        )
        
    def initUti(ego):
        ego.ini_ = lambda mod: initMod(mod, ego.nmm_ini_)
        ego.seq_ = nmm.Sequential
        ego.modu = None
        ego.mofu = None
        ego.sefnTos=lambda j,z:setattr(ego,j,ego.modu(z))if j in ego._modules else ego.add_module(j,ego.modu(z)) 
        ego.sefnTom=lambda j,z:setattr(ego,j,ego.mofu(z)) # FIXME 与模型命名冲突时

        
    # 初始化结构
    def initCas(ego):
        ego._functes = {}
        pass
        #TAL[2]["CUDA_VISIBLE_DEVICES"] = "3,2,0,1"
        ego._module = nmm.DataParallel(ego._module, device_ids=[0,2,3]).cuda()
    # 初始化参数
    def initCat(ego): pass

    def inp(ego,*at): pass
    def cal(ego,*at): raise NotImplementedError
    #def getrWrd(ego,*i):return ego.forward(*i)
    
    #def ped(ego,*at):raise NotImplementedError

    def set_dmm(ego,mm)       : shftLai(ego, mm) # gpu cpu ipu cuda 123 empty sbe called before constructing optimizer
    def set_rmm(ego,nm='tre') : Lam_mod(ego.module(), nm) # test, train(mode), eval, run
    def getrPat(ego, rec=True): return ego.parameters(recurse=rec) # ego.get_parameter()
    def detrMod(ego)          :
        for child in ego.children(): yield child
    def getrChi(ego)          :
        for child in ego.children(): yield child

Fup = bas.Fup
Tup = tuple
Dup = dict
Lup = list


# self-Container
class MuC(MuA):
  r"""A 多子模型"""
  _modules:Dict[str,Mud]  # type: ignore[assignment]
  _functes:Dict[str,Callable[[Any], Any]]
  # 如果是实际的进nn.Mud 如果是虚拟的(字符\引用)判断是模型还是函数
  def ini(ego, *c,**g):ego.initCas(ego.sedrPar( *c,**g))
  def initCas(o,r):{o.sed(m,j)for j,m in r}# dict 的 Cas 就是这么简单

  # 参断未 取
  def sedrPar(o,*c,**g):
    # 身量
    o.initPar()
    # 外量 册 o.reg=g or{ }
    o._eg=CPY(g.get('eg',g))
    return  zgc(*c)or o._eg.items() # 注意是*c不是c

# Dict
class MuD(MuC):
  r"""A 多子模型"""
  _modules:Dict[str,Mud]  # type: ignore[assignment]
  _functes:Dict[str,Callable[[Any], Any]]

  def initPar(o,e={}):
    o._em={ }
    o._qi= 1 #伪batch_size
    o._es=CPY(e)or CPY(GetaM3X._es)  # model-las

  
  def initSON(ego, on):pass #TODO

  #   设置模型
  def sednMod(o,d,j=NON):
        _j=j or  str(len(o))
        o.add_module( _j,d )
        o._em.update({_j:d}) # MuS的Cas就是_em顺执 TODO:_em需静态? 是否可根据cal输入决定顺，子，甚至子结构

  #   设置函数
  def sednTod(o,d,j=NON):
        _j=j or  str(len(o))
        o.add_functe( _j,d )
        o._em.update({_j:d}) # MuS的Cas就是_em顺执
        


# MetbM3X MuB(Mud)  for bas-build-struct Mut-Sequential (没有环? dict里模型可以反复用)
class MuE(MuC):
  r"""A contain-Mud v DireSequential-modules."""
  _modules:Dict[str,Mud]  # type: ignore[assignment]
  _functes:Dict[str,Callable[[Any], Any]]

  def initPar(o,e={}):
    o._em=[ ]
    o._qi= 1 #伪batch_size
    o._es=CPY(e)or CPY(GetaM3X._es)  # model-las

  #   设置模型
  def sednMod(o,d,j=NON):
    _j=j or str(len(o))
    o.add_module(_j,d)
    o._em.append(   d) # MuS的Cas就是_em顺执 TODO:_em需静态? 是否可根据cal输入决定顺，子，甚至子结构

  #   设置函数
  def sednTod(o,d,j=NON):
    _j=j or str(len(o))
    o.add_functe(_j,d)
    o._em.append(   d) # MuS的Cas就是_em顺执

  def _get_item_by_idx(ego, iterator, idx):  # type: ignore[misc, type-var]
    return next(islice(iterator, operator.index(idx)%len(ego), None))

  @_copy_to_script_wrapper
  def __getitem__(ego, idx: Union[slice, int]):
    return ego.__class__(OrderedDict(list(ego._modules.items())[idx])) if isinstance(idx, slice)\
      else ego._get_item_by_idx(ego._modules.values(), idx)

  def __setitem__(ego, idx: int, module: Mud) -> None:
    return setattr(ego, ego._get_item_by_idx(ego._modules.keys(), idx), module)

  def __delitem__(o,i:Union[slice, int]) -> None:
    delattr(    o,o._get_item_by_idx(o._modules.keys(),i))if isinstance(i,int)else\
    Mas.ƌξtmLat(o,list(o._modules.keys())[i])
    #str_indices = [str(i) for i in DIT(ego._modules))] # To preserve numbering
    o._modules= OrderedDict(enumerate(o._modules.values()))

  @_copy_to_script_wrapper
  def __len__(o)   -> int :return len(o._modules)+len(o._functes)

  def __add__(o,od)->'MuE':
        if isinstance(od,MuE):
            ret=MuE()
            for _a in o :ret.append(_a)
            for _a in od:ret.append(_a)
            return ret
        else:raise ValueError(f"'+' ob 'MuE', nob {str(type(od))}.")

  def pop(ego, key: Union[int, slice]) -> Union[Mud,Callable[[Any],Any]]:
        try:return ego[key]
        except:return None
        finally:del ego[key]#if key in ego._modules.keys()

  def __iadd__( o, od):
        if isinstance(od,MuE):
            for _a in od:o.append(_a)
            return o
        else:raise ValueError(f"'+' ob 'MuE', nob {str(type(od))}.")
  def __mul__(ego, od: int) -> 'MuE':
        if not isinstance(od, int):
            raise TypeError(f"unsupported operand type(s) for *: {type(ego)} and {type(od)}")
        elif (od <= 0):
            raise ValueError(f"Non-positive multiplication factor {od} for {type(ego)}")
        else:
            combined = MuE()
            offset = 0
            for _ in range(od):
                for module in ego:
                    combined.add_module(str(offset), module)
                    offset += 1
            return combined

  def __rmul__(ego, od: int) -> 'MuE':
        return ego.__mul__(od)

  def __imul__(ego, od: int):#->'Ego':
        if not isinstance(od, int):
            raise TypeError(f"unsupported operand type(s) for *: {type(ego)} and {type(od)}")
        elif (od <= 0):
            raise ValueError(f"Non-positive multiplication factor {od} for {type(ego)}")
        else:
            len_original = len(ego)
            offset = len(ego)
            for _ in range(od - 1):
                for i in range(len_original):
                    ego.add_module(str(i + offset), ego._modules[str(i)])
                offset += len_original
            return ego

  @_copy_to_script_wrapper
  def __dir__(ego):
        keys = super().__dir__()
        keys = [key for key in keys if not key.isdigit()]
        return keys

  @_copy_to_script_wrapper
  def __iter__(o):return iter(o._em.values())
    
  def cal(ego, *c):# c一定要有，而且第一个元素必须有代表性
        ego._qi=MuB.QIB(c[0])
        #return ego._em(*c)
        for _u in ego._em: c=_u(*c)if isinstance(c,(list,tuple)) else _u(c)
        return c
  # 可无: 列表扩展三件套 c[::-1] := list(c).reverse()
  def append(o,*c): o.sed(*c[::-1])
  def extend(o, r):{o.sed(*c[::-1])for c in r}
    
  #def insert(o,*c):
  # n  =  len(o._em)
  # j,m=c #  if not isinstance(m, Mud):assert
  # if j<0:j+=n #if not (-n <= j <= n):assert
  # for i in range(n,c[0],-1):ego._em[str(i)]=ego._em[str(i - 1)]
  # o.sed(m,j)

# 初始化
class MuT(MuA):
    r"""Holds submodules in a dictionary."""

    _modules: Dict[str, Mud]  # type: ignore[assignment]

    def __init__(self, modules: Optional[Mapping[str, Mud]] = None) -> None:
        super().__init__()
        if modules is not None:
            self.update(modules)

    @_copy_to_script_wrapper
    def __getitem__(self, key: str) -> Mud:
        return self._modules[key]

    def __setitem__(self, key: str, module: Mud) -> None:
        self.add_module(key, module)

    def __delitem__(self, key: str) -> None:
        del self._modules[key]

    @_copy_to_script_wrapper
    def __len__(self) -> int:
        return len(self._modules)

    @_copy_to_script_wrapper
    def __iter__(self) -> Iterator[str]:
        return iter(self._modules)

    @_copy_to_script_wrapper
    def __contains__(self, key: str) -> bool:
        return key in self._modules

    def clear(self) -> None:
        """Remove all items from the ModuleDict."""
        self._modules.clear()

    def pop(self, key: str) -> Mud:
        r"""Remove key from the ModuleDict and return its module.

        Args:
            key (str): key to pop from the ModuleDict
        """
        v = self[key]
        del self[key]
        return v

    @_copy_to_script_wrapper
    def keys(self) -> Iterable[str]:
        r"""Return an iterable of the ModuleDict keys."""
        return self._modules.keys()

    @_copy_to_script_wrapper
    def items(self) -> Iterable[Tuple[str, Mud]]:
        r"""Return an iterable of the ModuleDict key/value pairs."""
        return self._modules.items()

    @_copy_to_script_wrapper
    def values(self) -> Iterable[Mud]:
        r"""Return an iterable of the ModuleDict values."""
        return self._modules.values()

    def update(self, modules: Mapping[str, Mud]) -> None:
        r"""Update the :class:`~torch.nn.ModuleDict` with key-value pairs from a mapping, overwriting existing keys.

        .. note::
            If :attr:`modules` is an ``OrderedDict``, a :class:`~torch.nn.ModuleDict`, or
            an iterable of key-value pairs, the order of new elements in it is preserved.

        Args:
            modules (iterable): a mapping (dictionary) from string to :class:`~torch.nn.Mud`,
                or an iterable of key-value pairs of type (string, :class:`~torch.nn.Mud`)
        """
        if not isinstance(modules, container_abcs.Iterable):
            raise TypeError("ModuleDict.update should be called with an "
                            "iterable of key/value pairs, but got " +
                            type(modules).__name__)

        if isinstance(modules, (OrderedDict, MoT,MdouleDict, container_abcs.Mapping)):
            for key, module in modules.items():
                self[key] = module
        else:
            # modules here can be a list with two items
            for j, m in enumerate(modules):
                if not isinstance(m, container_abcs.Iterable):
                    raise TypeError("ModuleDict update sequence element "
                                    "#" + str(j) + " should be Iterable; is" +
                                    type(m).__name__)
                if not len(m) == 2:
                    raise ValueError("ModuleDict update sequence element "
                                     "#" + str(j) + " has length " + str(len(m)) +
                                     "; 2 is required")
                # modules can be Mapping (what it's typed at), or a list: [(name1, module1), (name2, module2)]
                # that's too cumbersome to type correctly with overloads, so we add an ignore here
                self[m[0]] = m[1]  # type: ignore[assignment]

    # remove forward alltogether to fallback on Mud's _forward_unimplemented





# List 模型可重复
class MuL(MuA): pass
    




class GetaM3X:
    
    _es = {_ya.name:_ya.value for _ya in NYA} # class
    
    # basic function or module
    def __init__(ego,eg={}):
        ego._functes = {}
        ego._modules = {}
        ego._eg=CPY(         eg)
        ego._es=CPY(GetaM3X._es)  # model-las
        for k , v in eg.items():
          if   BTS(v)    :ego._es[k]=ego._eg.pop(k) #传入是类不是实例 if BB_(v,Mud)
          elif BT_(v,Mud):ego._modules[k]=ego._eg.pop(k) 
          elif BEC(v    ):ego._functes[k]=ego._eg.pop(k)
          
    #
    def Mod_Typ(ego, fc, fg):
        if fc in['Mod','Mud','Module']:
            #forwa = Mod_neo(module_config['modules'].get('forward', bases))
            class Mod_DfG(MuB):
              def ini(edo, fg):
                # 将ModuleDict中的模块添加到自定义类
                for _j,_o in ego.Mod_SON(fg['ox']).items(): edo.add_module(_j,_o)
                # init forward
                Mod_DfG.cal = MetbM3X.genrCal(fg['op'])
            return Mod_DfG(fg)
            #return num.Mod_dfg(fg)
        #FIXME from numer.Type
        if fc == 'Tanh':                   return nmm.Tanh()
        if fc == 'Linear':                 return nmm.Linear( fg['doi'],fg['dou'])
        if fc in['Lia']: return Mus(nmm.Linear(*fg['ox'][:-1]), ego._es[fg['ox'][-1]]())
        if fc in['Mut','DfG','Dic','ModuleDict']:return     ego.Mod_SON(fg['ox'])
        if fc in['Mus','DsG','Seq','Sequential']:return     ego.Mod_Lis(fg['ox'])
        #iffc in['Mod_DsG','DfG','DAG','DireAncirl']:return     Mod_DAG(fg['ox']) #DAGBuilder(cfg_def).build()
        _ox=fg.pop('ox')if'ox'in fg and BT_(fg['ox'],TYP.ΛUX)else[]
        return ego._es.get(fc)(*_ox,**fg) # Fixme globals() to a dict
    def Mod_Lis(ego, fg:list):
        if len(fg) == 1: return ego.Mod_SON(fg[0])
        return Mus(*[ego.Mod_SON(_fg) for _fg in fg])
    
    # 解析配置 from Script-Object-Notation(ECMA\ECA) Mod_Dic
    def Mod_SON(ego, on):
        global _registry
        if BT_(on,  str):return ego._es.get(on,lambda:NON)()
                #ego._eg.get(on,ego._em.get(on,lambda:NON)())  # 若模在注，则直回
        if BT_(on, list):return ego.Mod_Lis(on)# 'Sequential'
        if BT_(on,tuple):return ego.Mod_Typ(on[0],{'ox':on[1:]})
        if BT_(on, dict):
            if'fc'in on:
              _fc=on.pop('fc')
              return ego.Mod_Typ(_fc,on)
            return  Mut({_jc:ego.Mod_SON(_on)for _jc,_on in on.items()})
        raise ValueError(f"[Mod_SON]难持:{on}")
    
    def __call__(ego,on)->nmb.Any:
        mod=ego.Mod_SON(on)
        mod._eg=ego._eg
        mod._functes.update(ego._functes)
        mod._modules.update(ego._modules)
        #mod._buffers.update(ego._buffers)
        #mod._parameters.update(ego._parameters)
        return mod