from.__deps_ import*
# FIXME Mod_Dal

# Distribution-format for class Mod_Val(nmm.Module)
class Mod_Dal(nmm.Module):
  def __init__(ego, dim_onp:int, dim_iup:int, t_val={'loc':[('lin',1)], 'std':'dia'}, n_ini=None, dmm=None):
    super().__init__()
    ego._jc     = ego.__class__.__name__
    ego.cfg_dmm = num.fmrtDmm(dmm)
    ego.mod_val = nmm.ModuleDict()  # [22O15]

    if isinstance(n_ini, list):
      for _ini in n_ini: pass #FIXME
    else:    
      ego._nn_ini_= bas.Dic(
               bia = lambda bias: nmm.init.constant_(  bias, 0),
               wei = lambda weit: nmm.init.orthogonal_(weit, gain=0.01)) if n_ini is None else n_ini
      def ini_(_nn_mod): return num.initMod(_nn_mod, ego._nn_ini_)
      for k_val, _tt_val in t_val.items():
        # FIXME multi-val
        ego.mod_val[k_val] = ini_(nmm.Linear(dim_onp, dim_iup).to(**ego.cfg_dmm))


class Categorical(Mod_Dal):
  def __init__(ego, dim_onp, dim_iup, _nn_ini = None, ctd=True):
    super().__init__(dim_onp, dim_iup, n_ini = _nn_ini)
  def forward(ego, onp, tfg_aci=None):
    x = ego.mod_val(onp)
    if tfg_aci is not None:
      x[tfg_aci == 0] = -1e10
    return Dal_Ctg(logits=x)

# https://zhuanlan.zhihu.com/p/268100059
class ModgDal(Mod_Dal):
  def __init__(ego, dim_onp, dim_iup, n_ini = None, f_ctd=True, dmm=None):
    if f_ctd:
      super().__init__(dim_onp, dim_iup, t_val={'loc':[('lin',1)]}, n_ini = n_ini, dmm=dmm)
      #ego.logstd =  AddBias(zro_act) # DEBUG
      #ego.mod_val_scl = lambda onp: nmb.sigmoid(ego.logstd) * 0.5 # KFAC implementation. FIXME to module
      ego.mod_val_scl = lambda onp: nmb.eye(dim_iup).to(**ego.cfg_dmm) #* 0.875
    else:
      super().__init__(dim_onp, dim_iup, n_ini = n_ini, t_val=[[('lin',1)],[('lin',1)]], dmm=dmm)
    try:
      ego.to(**ego.cfg_dmm)    # ego.to(device)
    except:
      print(f"[Mod_Dal] | CUDA error!")
      pass
  def forward(ego, onp):
    #return Dal_Nrm(ego.mod_val['loc'](onp), ego.mod_val_scl(onp))
    return DalMNrm(ego.mod_val['loc'](onp), ego.mod_val_scl(onp))

class Bernoulli(Mod_Dal):
  def __init__(ego, dim_onp, dim_iup, use_orthogonal=True, gain=0.01):
    super().__init__()
    _nn_npi = [nmm.init.xavier_uniform_, nmm.init.orthogonal_][use_orthogonal]
    ego._nn_ini_= bas.Dic(
       bia = lambda bias: nmm.init.constant_(bias, 0),
       wei = lambda weit: _nn_npi(weit, gain=gain)  # FIXME ego._nn_npi
      ) 
    def ini_(_nn_mod):
      return num.initMod(_nn_mod, ego._nn_ini_)
    
    ego.linear = ini_(nmm.Linear(dim_onp, dim_iup))

  def forward(ego, x):
    x = ego.linear(x)
    return Dal_Brn(logits=x)

class AddBias(nmm.Module):
  def __init__(ego, bias):
    super().__init__()
    ego._bias = nmm.Parameter(bias)

  def forward(ego, x):
    if x.dim() <= 2:    # FIXME ARES
      bias = ego._bias.t().view(1, -1)
    else:
      bias = ego._bias.t().view(1, -1, 1, 1)

    return x + bias