"""
 #  num-muti :: net-las 网类集
 @  E.C.Ares
 !  MIT DIVIƷON
 `  Las of nets builtin numer-python 自构模型 若不局限于前馈，则神经网络结构也是一种超参数。
  - 神经架构搜索 (Neural Architecture Search, NAS) 以自动化搜索算法(遗传\强化\进化)遍历网络架构空间动态编译网络结构
  - 超参数优化: (网格\随机\贝业)自动调整模型的超参数，如学习率、批量大小、正则化强度..
  - 特征工程自动化: 自动识别和转换输入数据中的重要特征，减少人工特征工程的工作量。
  - 模型堆叠与集成: 自动选择并组合多个模型，形成更强大的集成模型，如Stacking、Bagging、Boosting等。
  - 可插拔的模块化设计: 设计允许用户定义或修改组件（如损失函数、优化器、激活函数等）的框架，使模型更加灵活可定制
  - 如果cell作为一个层次，那么组合cell的结构也可以被看做一个层次，因此有研究人员就此提出了基于分层(Hierarchical)的思想
  - # 结构编码作为构建搜索空间
  - #NEAT[3]，它通过生长的变长基因编码的方式来编码网络结构。基因主要分为两个基因型，一个代表神经元的链接，一个代表了他们之间的权重，属于直接编码
"""

{
  "model": {
    "name": "Hierarchical Transformer Encoder",
    "layers": [
      {
        "type": "MultiHeadSelfAttentionCell",
        "d_model": 512,
        "num_heads": 8,
        "dropout": 0.1
      },
      {
        "type": "PositionwiseFeedForward",
        "d_model": 512,
        "d_ff": 2048,
        "dropout": 0.1
      },
      {
        "type": "LayerNormalization"
      }
    ],
    "cell_repeats": 6,  # Transformer Encoder由6个这样的cell组合重复构成
    "embedding": {
      "type": "Embedding",
      "vocab_size": 10000,
      "d_model": 512
    },
    "output": {
      "type": "Linear",
      "in_features": 512,
      "out_features": 10  # 假设为10分类任务
    },
    "final_activation": "Softmax"
  }
}