"""
 #  转换函数 shf-lams
 @  E.C.Ares
 !  MIT LICENSE
 `  built in pkp for numpy(nmp), pyTorch(nmb) tensor
    Las 量对象的类型(转换)
    Les 结构内对象(转换)
"""
# r(import-refs)
#       r.. im
from .__deps_ import _LC_DEV
from .iniLam import *
#       r.. as
pass
# s
_JC_NYM = 'lam_shf'
# to.() = 畨 娄


_FC3DEV = ['cpu', 'cud', 'gpu']
_FC3REV = ['otg', 'non']
_FC3PEV = ['rut', 'cut']
_JC_LOC = ['locate','L','loc'] # file.pth
_JC_DRC = ['direct','R','drc'] # dir.name
_JC_LOT = ['layout','E','lot'] # mkldnn sparse ..
_JC_DEV = ['device','V','dev'] # 地环
_JC_DYP = ['dtype', 'T','typ'] # data.type
_JC_TAN = ['train', 'P','tre'] # metaclass=num.MetaM3X.train]
_JC_RAN = ['tests', 'B','vlu'] # metaclass=num.MetaM3X.eval ]

# 格式规范 依赖执行无关
btp_nmb:lambda x:bas.bet(x,nmb.dtype)
bvc_nmb:lambda x:bas.bet(x,nmb.device)
val_key:lambda x,c:x.get(c)

G=globals()
OYP('Y_I',G) # typeVar

'''
shft = dddd(dict(
   i = shftLai, # 畨
   r = shftLar, # 娄: 数
   s = shftLas, # 类: 類
   n = shftLan))# 粦: 亃\㔂\粼\斴\甐\䚏\翷
'''

# 频率高的特殊 shftLai
shftLaiDvmb=lambda x:x.detach().cpu()

# Abst-Converter, not Shifter or Mender 轻改变 val() 辅音开头，说明不是自处理
class Cnv(TYM_.Gen[Y_I]):
    """ Las for converters. """
    @TYB._CM
    def ins(ego, ox, am:TYM_.Cal[[Y_I],TYP.NSX]):
        #if BT_(ox, dict):return {_:am(e) for _,e in ox.items()} #cel:单层
        if BT_(ox, dict):return    {_:Cnv.ins(e,am)for _,e in ox.items()} # FIXME 可转移
        if BT_(ox, list):return      [Cnv.ins(e,am)for   e in ox        ]
        if BT_(ox,tuple):return tuple(Cnv.ins(e,am)for   e in ox        )
        if hasattr(ox,'__dict__'):
            _ox = type(ox)()  # 创建同类型的新实例
            for k,e in ox.__dict__.items():setattr(_ox,k,Cnv.ins(e,am))
            return _ox
        #if BT_(ox, 'it'):return type(ox)(*[Cnv.ins(e,am) for e in ox]) # FIXME iterator
        try:return am(ox)
        except:return ox
    @TYB._CM
    def vm_(ego, ox:Y_I): raise NotImplementedError
    @TYB._CM
    def vmb(ego, ox:Y_I): raise NotImplementedError
    @TYB._CM
    def vmp(ego, ox:Y_I): raise NotImplementedError

class Cnv_vm_(Cnv):
    """ Las for numpy-converters. """
    @TYB._CM
    def vm_(ego, ox, ad=int):return ad(ox) #astype
    @TYB._CM
    def vmb(ego, ox):return nmb.tensor(ox)
    @TYB._CM
    def vmp(ego, ox):return nmp.array( ox) #nmp.array 相当于所有层

# torch
class Cnv_vmb(Cnv):
    """ Las for pytorch-converters. """
    @TYB._CM
    def vm_(ego, ox:nmb.Tensor):return ox.detach().cpu().tolist() 
    @TYB._CM 
    def vmb(ego, ox:nmb.Tensor, ad=nmb.float):return ox.to(ad)
    @TYB._CM # ox.detach().cpu().numpy()
    def vmp(ego, ox:nmb.Tensor):return shftLaiDvmb(ox).numpy() #先隔离计算图

# numpy
class Cnv_vmp(Cnv):
    """ Las for numpy-converters. """
    @TYB._CM
    def vm_(ego, ox):return ox.tolist() # scalar 会自适应变 nmp.array(1).tolist() -> 1
    @TYB._CM
    def vmb(ego, ox):return nmb.from_numpy(ox)
    @TYB._CM
    def vmp(ego, ox, ad=nmp.float32):return ox.astype(ad)


cnv_def = {
   'nmp':{
      'nm_':Cnv_vmp.vm_,
      'nmb':Cnv_vmp.vmb},
   'nmb':{
      'nm_':Cnv_vmb.vm_,
      'nmp':Cnv_vmb.vmp},
   'nm_':{
      'nmb':Cnv_vm_.vmb,
      'nmp':Cnv_vm_.vmp}}

#FIXME ins & heur-class
cnvtVec=bas.Dih(cnv_def)


# 置型转换 'cuda' if available(it) 
_FG_DMM_DEF  = {
    _JC_DEV[ 0]:DOX.DEV,
    _JC_DYP[ 0]:TYP._3d} # TODO layout
_KY_DMM =   TYP.ASX(_FG_DMM_DEF.keys())
# 更改数据组织形式，而不是数
def shftLanDdic( ox:TYP.NSX, fh={'t':NON}):
    ret = {}
    if bas.bet(ox, NON):return ret
    #if bas.bet(ox, str): FIXME elif
    if  'half'in ox:ret[_KY_DMM[0]]= TYP._3I
    elif 'dbl'in ox:ret[_KY_DMM[0]]= TYP._3P
    elif 'int'in ox:ret[_KY_DMM[0]]= TYP._3f
    else           :ret[_KY_DMM[0]]= TYP._3d  # if 'float' in dmm
    if   'cpu'in ox:ret[_KY_DMM[1]]= DOX.DEC
    elif nmb.cuda.is_available():
      i = bas.N0I_str()
      if bas.bet(i,NON):ret[_KY_DMM[1]]= DOX.DEV
      else         :ret[_KY_DMM[1]]= DOX.DEI(i)
    else           :ret[_KY_DMM[1]]= DOX.DEV
    return ret

def frmtCFG_DMM( fg):
    _fg=bas.CPL( fg) if bas.bet( fg,TYP.TSX) else shftLanDdic(fg) # t的那一横
    if _fg['V']=='m':return _fg
    _fg=bas.CPL( fg)
    return\
    bas.Dic_def(_fg,bas.CPL(_FG_DMM_DEF))
# W3模存取
_FG_MOD_DEF=bas.Dic( F =FRB, S =FЯB)
#_KY_MOD   =TYC.ASX(_FG_MOD_DEF.keys())
def frmtCFG_MOD( fg) :
    _fg  =  CPL( fg)   # t的那一横
  # FIXME comlize
    _fg['L'] =  bas.Pth(_fg['L'][:3])\
              +         _fg['L'][:3]if _fg['L'][:3] in _FC3PEV\
          else  bas.Pth(_fg['L'],fb=FRB) # os.makedirs(os.path.dirname(_fc))
    return  bas.Dic_def(_fg,CPL(_FG_MOD_DEF))

_FG_LAI_DEF=bas.Dic( D ='m', L =NON)
def fmrtCFG_LAI( fg) :
    _fg  =  CPL( fg)   # t的那一横
    return  bas.Dic_def(_fg,CPL(_FG_LAI_DEF))

# 作用于张量 (Tensor) 的方法
"""
# _apply(lam) 内部会执行3步:
对ego.children() 进行递归的调用；
使用fn对 ego._parameters 中的参数及其 gradient 进行处理；
使用fn对 ego._buffers 中的 buffer 进行处理。
"""
# CHECK: if module changed FIXME: outfile 
def Lam_mod( ox:TYP.M3X, am):
    if   am  in _JC_TAN: ox.train(  )
    elif am  in _JC_RAN: ox.eval(   )
    elif bas.bet(am, 'lam'): ox.apply(am) # 模型的训练/评估模式，区别于Tensor.apply()
    else:  raise NotImplementedError

def loadMod( ox:TYP.M3X, lc, fg):
    # TODO map_location strict
    try:
      ox.load_state_dict(
                nmb.load(lc, map_location=fg['V']), strict=fg['S'])
      print(f"[{_JC_NYM} | mod] : use {lc}")
    except: 
      try: ox=nmb.load(lc, weights_only=False) #FIXME ox.load(lc)
      except: print(f"[{_JC_NYM} | mod] : no-use {lc}")

# TODO Place Params
def tʃumMod( ox:TYP.M3X, lc):
    try:
      nmb.save(ox, lc)
      print(f"[{_JC_NYM} | [T]mod.mPrm] : savt {lc}")
    except:
      try:
        #os.makedirs(os.path.dirname(lc))
        nmb.save(ox.state_dict(), lc)
        print(f"[{_JC_NYM} | [T]mod.mPrm] : savt {lc}")
      except: raise NotImplementedError

LaiXPrm = dict(
  otg   = None,
  non   = initMod_ran
)

#模型的行略  更改[张量]所在ノ畨(田置): 栗: .to( ), .save( ), .load( )
def Dmm_sor( ox:TYP.N3X, fh={'V':'m'}): 
    
    ox.to(**frmtCFG_DMM(fh))
# Reset Mod:mod_objects,loc_strings,cfg_dicts[D:device,S:Strict]
def LaiRMod( ox:TYP.M3X, fg:TYP.TSX=bas.Dic( D='cpu', S=FЯB)):
    _fg  =  frmtCFG_MOD( fg)
    print(f"[{_JC_NYM} | mod] : load {GΞ_(   ox,'_jc', ox.__class__.__name__)} by {_fg}")
    if _fg['J']in _FC3REV:LaiXPrm[_fg['J']]( ox)
    else:
      if'V'not in _fg:_fg['V'] = _LC_DEV
      loadMod(ox,ZCL(_fg['L'],_fg['J']),_fg)

# Place Mod:mod_objects,loc_strings,cfg_dicts[F:Force,S:Structure]
def LaiPMod( ox:TYP.M3X, fg:TYP.TSX=bas.Dic( F =FRB, S =FЯB)):
    _fg  =  frmtCFG_MOD( fg)
    #if VAR['PRINT'] or VAR['DEBUG']:
    print(f"[{_JC_NYM} | mod] : load {GΞ_( ox,'_jc', ox.__class__.__name__)} by {_fg}")
    if _fg['S']:ox= ox.state_dict() # 只存其参
    try   : tʃumMod( ox,_fg['P'])
    except: print(f"[{_JC_NYM} | [E]mod.mPrm] : not-dir {_fg['P']}")

#to ΛUX?M3X
def Lai_N3X( ox:TYP.N3X, fh) :
    _ox  =   ox.detach(    )
    _fh  =      frmtCFG_DMM( fh)
    Dmm_sor(_ox,        _fh)


# 更改设备放置 memory <-> cpu, cuda <-> cpu, cuda
def Lai_W3X( ox:TYP.M3X, fh):
    _fh  =  fmrtCFG_LAI( fh)
    if _fh['V']in['m','mem']:return\
    LaiPMod( ox,        _fh)       #None
    if  bas.bet(_fh['L'],   str):return\
    LaiRMod( ox,        _fh)
    Lai_N3X( ox,        _fh)

#def Lar_sor( ox:nmm.Module,      ai): #更改数据类型



def shftLai( ox, fh): return ox.to(**frmtCFG_DMM(fh))

shftLarTNmp=Cnv_vmb.vmp
tsr =  lambda x,dt:nmb.as_tensor(x) if dt is None else nmb.tensor(x, dtype=dt)



#dt=Typ_nmp(**fg_typ)
def Typ_nmp(T='f',M='c',**g):return TYP.NMP[T][M]

# Las 类泛 Los 类实
# Lar 量泛 Lor 量实(包括类的实例)

#FIXME: NON INF
def shftLar_Num( ox:TYP.NSX, g={'M':'c'}):
    _om=nmp.array(           ox      )
    _fc=  g.get('T',        _om.dtype)
    if  BT_(_fc,str):return _om.astype( Typ_nmp(**g)                )
    _fi=  g.get('M',FЯB)   #_fc.__class__.__class__==nmp._DTypeMeta
    if  _fi:         return _om.astype( Typ_nmp(T=str(_fc)[0],M=_fi))
    return                  _om.astype( _fc                         )

def shftLer_Num( ox:TYP.NSX, g={'A':FЯB}):
    #fb_abv= fg['A']
    if    g.get('A',FЯB    ):return shftLar_Num(ox,g)
    if           ox  is NON :return ox
    _fc_typ= g.get('T',NON) # FIXME 
    #if  bas.bet( ox,TYP[30]):return shftLarTNmp(ox).astype(_fc_typ) if _fc_typ else shftLarTNmp(ox)
    if  BT_( ox,TYP._0I):return ox.astype(_fc_typ)  if _fc_typ else ox
    if  BT_( ox,TYP._0I):return ox
    # namedtuple
    
    if  BT_( ox,TYP.ΛUX):return None if  len( ox) == 0 else [shftLer_Num(ex, g) for ex in ox]
    if  BT_( ox,TYP.TSX):return {k:shftLer_Num(ex, g) for k, ex in ox.items()}
    if  BT_( ox,'it'   ):return type(ox)(*[shftLer_Num(ex, g) for ex in ox])
    if  BT_( ox,   'sc'):return nmp.array(ox)
    raise TypeError("not support item type: {}".format(type(ox)))
def toN( *c,**g): return shftLer_Num( *c,**g)



def getrItm( fh:TYP.TSX, im=['dtype','T'], om= nmb):
  _im = NXD(im) if bas.bet(im,TYP.ΛUX) else im
  return fh if BT_(fh, GΞ_(om,_im)) else bas.grt(fh,im,NON) if BT_(fh,TYB.TSX) else NON
# FIXME GI_(fh,im[0]) 依次GI_ 等价于 aee(GI_(fh,dd)for dd in im)

#TypedDict['']
# ik ignore key
def shftLar_Tsr( ox:TYP.NSX, fh:TYP.TSX, ik: list = ['SCL'], gk=[], fb=False):
    # FIXME
    _dv=getrItm(fh,_JC_DEV)
    _dt=getrItm(fh,_JC_DYP)
    if      bas.bet( ox,NON    ):return NON # FIXME
    if      bas.bet( ox,TYP._0X):return  ox if fb\
                               else nmb.as_tensor(ox).to(_dt) if _dt is not NON\
                               else nmb.as_tensor(ox)
    #if     bas.bet( ox,TYP._1X):return  ox # FIXME MATH
    if      bas.bet( ox,TYP.Λ3X):return      ox.to(  _dt) if _dt is not None else ox
    if      bas.bet( ox,TYP.TSX):return bas.typ( ox)((k,toT(v, _dt, ik)) for k,v in ox.items()) if fb\
                               else Tsr_Dix(     {k:toT(v, _dt, ik)  for k,v in ox.items()}, gk)
    # V else     tsr( ox, _dt) if bas.bet(ox[0], TYP._1X)\# FIXME MATH
    if      bas.bet( ox,TYP.ΛUX):return bas.typ( ox)([]) if fb and len( ox) == 0\
                               else bas.typ( ox)([toT(v, _dt, ik) for v in ox]) if fb\
                               else nmb.tensor(TYB.ASX(ox), dtype=_dt, device=_dv)
    if      bas.bet( ox,TYP.Λ2X):return nmb.from_numpy(ox).to(_dt) if _dt is not None\
                               else nmb.FloatTensor( ox) if ox.dtype == nmp.float64\
                               else nmb.from_numpy(  ox, _dt)
    if      bas.bet( ox,'i'    ):return bas.typ( ox)( *[toT(t, _dt)      for t   in ox])
    

    raise TypeError("not support item type: {}".format(type(ox)))
def toT( *c,**g): return shftLar_Tsr( *c,**g)


shftLar_ = dict(
    n    = shftLer_Num
)
def shftLar( ox, fc='n'): return shftLar_[fc](ox)



def nPrm_ort(mod):
  pass
  
'''
nPrm_ = dict(
  otg = nPrm_ort,
  ran = nPrm_ran
)
'''

def    toD( ox:TYP.NSX, dev: str, igk: list = []):
  if   bas.bet( ox, nmb.nmm.Module):
    return  ox.to(dev)
  elif bas.bet( ox, nmb.Tensor):
    return  ox.to(dev)
  elif bas.bet( ox, Sequence):
    if bas.bet( ox, str):
      return  ox
    else:
      return [toD(t, dev) for t in  ox]
  elif bas.bet( ox, dict):
    new_item = {}
    for k in  ox.keys():
      if k in igk:
        new_item[k] =  ox[k]
      else:
        new_item[k] = toD( ox[k], dev)
    return new_item
  elif bas.bet( ox, Integral) or bas.bet( ox, Real):
    return  ox
  elif bas.bet( ox, nmp.ndarray) or bas.bet( ox, nmp.bool_):
    return  ox
  elif  ox is None or bas.bet( ox, str):
    return  ox
  else:
    raise TypeError("not support item type: {}".format(type( ox)))


# 包含数值的张量 [23A90] afc:.pop() -> .popleft()
def Tsr_Dix(tfc, afc=['stp']):
  ugd = tfc[afc[0]].unsqueeze(-1)
  #afc.popleft()
  if len(afc) > 1:
    for fc in afc[1:]:
      ugd = nmb.cat((ugd,tfc[fc].unsqueeze(-1)), -1)
  return ugd

def Tsr_Lix(tfc, afc=['stp']):
  ugd = tfc[afc[0]].unsqueeze(-1)
  #afc.popleft()
  if len(afc) > 1:
    for fc in afc[1:]:
      ugd = nmb.cat((ugd,tfc[fc].unsqueeze(-1)), -1)
  return ugd





def toL(item):

  if item is None:
    return item
  elif bas.bet(item, nmb.Tensor):
    return item.tolist()
  elif bas.bet(item, nmp.ndarray):
    return item.tolist()
  elif bas.bet(item, list) or bas.bet(item, tuple):
    return [toL(t) for t in item]
  elif bas.bet(item, dict):
    return {k: toL(v) for k, v in item.items()}
  elif nmp.isscalar(item):
    return item
  else:
    raise TypeError("not support item type: {}".format(type(item)))

def tensor_to_list(item):
  if item is None:
    return item
  elif bas.bet(item, nmb.Tensor):
    return item.tolist()
  elif bas.bet(item, list) or bas.bet(item, tuple):
    return [tensor_to_list(t) for t in item]
  elif bas.bet(item, dict):
    return {k: tensor_to_list(v) for k, v in item.items()}
  elif nmp.isscalar(item):
    return item
  else:
    raise TypeError("not support item type: {}".format(type(item)))



def get_tensor_data(data:TYP.NSX) -> TYP.NSX:
  """
  Overview:
    Get pure tensor data from the given data(without disturbing grad computation graph)
  """
  if bas.bet(data, nmb.Tensor):
    return data.data.clone()
  elif data is None:
    return None
  elif bas.bet(data, Sequence):
    return [get_tensor_data(d) for d in data]
  elif bas.bet(data, dict):
    return {k: get_tensor_data(v) for k, v in data.items()}
  else:
    raise TypeError("not support type in get_tensor_data: {}".format(type(data)))


def unsqueeze(data:TYP.NSX, dim: int = 0) -> TYP.NSX:
  if bas.bet(data, nmb.Tensor):
    return data.unsqueeze(dim)
  elif bas.bet(data, Sequence):
    return [unsqueeze(d) for d in data]
  elif bas.bet(data, dict):
    return {k: unsqueeze(v, 0) for k, v in data.items()}
  else:
    raise TypeError("not support type in unsqueeze: {}".format(type(data)))


if  bas.Her(__name__):
    a = nmb.tensor([1.0, 1.0])
    b = shftLarTNmp(a)
    print(b)