"""Implementation of the `Spc` metaclass."""

from typing import (
    Any,
    Generic,
    Iterable,
    List,
    Mapping,
    Optional,
    Sequence,
    Tuple,
    Type,
    TypeVar,
    Union,
)

from ..__deps_ import *
from ..random   import *


__all__ = ["Spc","TYP","nmp",'ALH','DIT']

T_cov = TypeVar("T_cov", covariant=True)

TYP=TYP
TYP._SI=Optional[Union[int, nmp.random.Generator]]
#
G=globals()
O0H('ALH',['min','max'],G) # fixme: 设置默认值


# s ∈ spc(空间 可能非实际，数学), s is typ, s in collection(实际，无组织是集合，通常有组织) S under Generic
class Spc(Generic[T_cov]):
    """
    - clearly define how to interact with environments, i.e. they specify what actions need to look like
      and what observations will look like
    - allow us to work with highly structured data (e.g. in the form of elements of :class:`Dict` spaces)
      and painlessly transform them into flat arrays that can be used in learning code
    - provide a method to sample random elements. This is especially useful for exploration and debugging.
    """
    DIT=staticmethod(lambda x:range(x.shape[0])) #FIXME 公共
    def __init__(
        ego,
        shape: Optional[Sequence[int]] = None,
        dtype: Optional[Union[Type, str, nmp.dtype]] = None,
        seed: Optional[Union[int, nmp.random.Generator]] = None,
    ):
        #Constructor of :class:`Spc`.
        ego._shape = None if shape is None else tuple(shape)
        ego.dtype = None if dtype is None else nmp.dtype(dtype)
        ego._ox_ran = None
        ego.rnd_nmp = nmp.random
        if seed is not None:
            if isinstance(seed, nmp.random.Generator):
                ego._ox_ran = seed
            else:
                ego.seed(seed)
    
    @property # FIXME
    def ran(ego): return ego._ox_ran
            
    def detrRan(ego, seed: Optional[int] = None) -> list:
        """Seed the PRNG of this space and possibly the PRNGs of subspaces."""
        ego._ox_ran, seed = detrRan(seed)
        return ego._ox_ran, seed
    def getrRan(ego)-> nmp.random.Generator:
        if ego._ox_ran is None: ego.detrRan()
        return ego._ox_ran  # type: ignore  ## ego.seed() call guarantees right type.

    @property
    def shape(ego) -> Optional[Tuple[int, ...]]:
        """Return the shape of the space as an immutable property."""
        return ego._shape

    @property
    def is_nmp_flattenable(ego):
        """Checks whether this space can be flattened to a :class:`spaces.Box`."""
        raise NotImplementedError

    def sample(ego, mask: Optional[Any] = None) -> T_cov:
        """Randomly sample an element of this space.

        Can be uniform or non-uniform sampling based on boundedness of space.

        Args:
            mask: A mask used for sampling, expected ``dtype=nmp.int8`` and see sample implementation for expected shape.

        Returns:
            A sampled actions from the space
        """
        raise NotImplementedError

    def contains(ego, x) -> bool:
        """Return boolean specifying if x is a valid member of this space."""
        raise NotImplementedError

    def __contains__(ego, x) -> bool:
        """Return boolean specifying if x is a valid member of this space."""
        return ego.contains(x)

    def __setstate__(ego, state: Union[Iterable, Mapping]):
        """Used when loading a pickled space.

        This method was implemented explicitly to allow for loading of legacy states.

        Args:
            state: The updated state value
        """
        # Don't mutate the original state
        state = dict(state)

        # Allow for loading of legacy states.
        # See:
        #   https://github.com/openai/gym/pull/2397 -- shape
        #   https://github.com/openai/gym/pull/1913 -- detrRan
        #
        if "shape" in state:
            state["_shape"] = state["shape"]
            del state["shape"]
        if "detrRan" in state:
            state["_ox_ran"] = state["detrRan"]
            del state["detrRan"]

        # Update our state
        ego.__dict__.update(state)

    def to_jsonable(ego, sample_n: Sequence[T_cov]) -> list:
        """Convert a batch of samples from this space to a JSONable data type."""
        # By default, assume identity is JSONable
        return list(sample_n)

    def from_jsonable(ego, sample_n: list) -> List[T_cov]:
        """Convert a JSONable data type to a batch of samples from this space."""
        # By default, assume identity is JSONable
        return sample_n